'use strict';

const Promise  = require("bluebird");
const eventBus = require('../index');
eventBus.init('amqp://codefresh.dev', 'microservice2');



eventBus.on('error', (err) => {
    console.error(err.stack);
});

eventBus.on('reconnecting', () => {
    console.log('Rabbitmq connection reconnecting');
});


eventBus.on('reconnected', () => {
    console.log('Rabbitmq connection reconnected');
});

eventBus.on('close', () => {
    console.log('Rabbitmq connection closed');
});

eventBus.on('blocked', () => {
    console.log('Rabbitmq connection blocked');
});

eventBus.on('unblocked', () => {
    console.log('Rabbitmq connection unblocked');
});


let start = () => {
    let totalRecieved = 0;
    let interval = setInterval(() => {
        eventBus.publish('myevent', { totalRecievd: totalRecieved});
        totalRecieved++;
        console.log(`sent message: ${totalRecieved}`);
    }, 2000);

    setTimeout(() => {
        console.log("STOPPING");
        clearInterval(interval);
        setTimeout(() => {
            process.exit(0);
        }, 100000);
    }, 500000)
};

eventBus.on('ready', () => {
    console.log('Rabbitmq ready');
    start();
});



// eventBus.subscribe('myevent', (msg) => {
//     return Promise.resolve()
//         .then(() => {
//             if (msg !== null) {
//                 totalRecieved++;
//                 console.log(`recieved message ${totalRecieved}: ${msg.content.toString()}`);
//             }
//         });
// });